VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   Caption         =   ""
   ClientHeight    =   1605
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   4560
   LinkTopic       =   "Form1"
   ScaleHeight     =   1605
   ScaleWidth      =   4560
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox picLevel 
      BorderStyle     =   0  'None
      Height          =   315
      Left            =   240
      ScaleHeight     =   21
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   281
      TabIndex        =   4
      Top             =   1080
      Width           =   4215
   End
   Begin VB.ComboBox cboCaptureDevices 
      Height          =   315
      Left            =   240
      TabIndex        =   3
      Text            =   "Combo1"
      Top             =   240
      Width           =   2775
   End
   Begin VB.CommandButton cmdRecording 
      Caption         =   ""
      Height          =   495
      Left            =   3240
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "  "
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   720
      Width           =   2535
   End
   Begin VB.Label Label2 
      Height          =   255
      Left            =   2880
      TabIndex        =   1
      Top             =   720
      Width           =   615
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const PBK_NUMOFCHANNELS As Long = 2
Private Const PBK_SAMPLERATE    As Long = 44100
Private Const PBK_BITNESS       As Long = 16
Private Const PBK_BUFFERSIZEMS  As Single = 0.3

Dim WithEvents tSound As clsTrickSound2
Attribute tSound.VB_VarHelpID = -1

Dim IsRecording As Boolean
Private m_lLevel    As Long

Private Sub Form_Load()
On Error GoTo error_handler

 Dim sName As Variant
 Set tSound = New clsTrickSound2
 ' // Fill combo with available playback devices
 For Each sName In tSound.CaptureDevices
  cboCaptureDevices.AddItem sName
 Next
  cboCaptureDevices.ListIndex = 0
Exit Sub

error_handler:
 If err.Number = 380 Then
  MsgBox "    !", vbCritical
  End
 Else
  MsgBox "Error has occured " & err.Number
 End If
End Sub

Private Sub cmdRecording_Click()
 On Error GoTo error_handler
 
 If tSound.IsUnavailable Then
    
        ' // Unitialize previous capture session
        tSound.Uninitialize
        IsRecording = False
        
        Exit Sub
        
    End If

    ' // Initialize new
    If Not tSound.InitCapture(PBK_NUMOFCHANNELS, _
                               PBK_SAMPLERATE, PBK_BITNESS, _
                               PBK_BUFFERSIZEMS * PBK_SAMPLERATE, _
                               cboCaptureDevices.ListIndex) Then
                                
      MsgBox "Error of capturing initialization", vbCritical
    End If
    
    tSound.StartProcess
    IsRecording = True
    capCount = 0

Exit Sub

error_handler:
 MsgBox "Error has occured " & err.Number
End Sub

Private Sub picLevel_Click()

End Sub

Private Sub picLevel_Paint()
    Dim lBin    As Long
    Dim lBins   As Long
    Dim fBinW   As Single
    Dim lActive As Long
    Dim lColor  As Long
    
    lBins = 22
    fBinW = picLevel.ScaleWidth / lBins
    lActive = -Int(-m_lLevel / 32768) * lBins
    
    For lBin = 0 To lBins - 1
        
        If lBin < lActive Then
            Select Case lBin
            Case 0 To 15:   lColor = vbGreen
            Case 16 To 20:  lColor = &H80FF&
            Case Else:      lColor = vbRed
            End Select
        Else
            lColor = &H808080
        End If
        
        picLevel.Line (lBin * fBinW, 0)-Step(fBinW - 3, picLevel.ScaleHeight), lColor, BF
        
    Next
    
End Sub

Private Sub tSound_NewData(ByVal DataPtr As Long, ByVal CountBytes As Long)
    Dim iSamp() As Integer
    Dim lMax    As Long
    Dim lIndex  As Long
    Dim lCh     As Long
    Dim lAbs    As Long
    
    If IsRecording Then

        ReDim Preserve iSamp(PBK_NUMOFCHANNELS - 1, CountBytes \ PBK_NUMOFCHANNELS \ 2 - 1)
        
        ' // Copy captured data to buffer
        tSound.CopyData VarPtr(iSamp(0, 0)), DataPtr, CountBytes
        
        For lIndex = 0 To UBound(iSamp, 2)
            For lCh = 0 To PBK_NUMOFCHANNELS - 1
                
                lAbs = Abs(iSamp(lIndex, lCh))
                
                If lAbs > lMax Then
                    lMax = lAbs
                End If
                
            Next
        Next
        
        m_lLevel = lMax
        
        picLevel.Refresh
        
    End If
    
End Sub














